'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj['default'] = obj; return newObj; } }

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var InertSelect = (0, _createReactClass2['default'])({
  propTypes: {
    disableDropdown: _propTypes2['default'].bool,
    isExpanded: _propTypes2['default'].bool.isRequired,
    isFocused: _propTypes2['default'].bool.isRequired,
    value: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number]).isRequired,
    children: _propTypes2['default'].arrayOf(_propTypes2['default'].node),
    containerClassName: _propTypes2['default'].string,
    optionsContainerClassName: _propTypes2['default'].string,

    onExpanded: _propTypes2['default'].func,
    onClosed: _propTypes2['default'].func,

    hoverIndex: _propTypes2['default'].number,
    activeIndex: _propTypes2['default'].number,
    selectedIndex: _propTypes2['default'].number,

    onHoverIndex: _propTypes2['default'].func.isRequired,
    onActiveIndex: _propTypes2['default'].func.isRequired,
    onSelectIndex: _propTypes2['default'].func.isRequired,

    style: _propTypes2['default'].shape({
      selectContainerStyle: _propTypes2['default'].object,
      optionsContainerStyle: _propTypes2['default'].object
    }),
    displayingChildRenderer: _propTypes2['default'].func
  },

  getDefaultProps: function getDefaultProps() {
    return {
      displayingChildRenderer: function displayingChildRenderer(x) {
        return x;
      },
      style: {}
    };
  },

  /*
    This attaches handlers to each prop.
   */
  createInteractiveOptions: function createInteractiveOptions() {
    var _this = this;

    // Can we cache this?
    return React.Children.map(this.props.children, function (c, i) {
      return React.cloneElement(c, {
        isHovering: _this.props.hoverIndex === i,
        isActive: _this.props.activeIndex === i,
        isSelected: _this.props.selectedIndex === i,
        onMouseOver: _this.props.onHoverIndex.bind(null, i, c.props.value),
        onMouseDown: _this.props.onActiveIndex.bind(null, i, c.props.value),
        onMouseUp: _this.props.onSelectIndex.bind(null, i, c.props.value)
      });
    });
  },

  getDisplayingChild: function getDisplayingChild() {
    var _this2 = this;

    var child = React.Children.toArray(this.props.children).filter(function (c) {
      return c.props.value === _this2.props.value;
    })[0];

    if (!child) {
      return null;
    }

    return React.cloneElement(child, {
      isDisplaying: true
    });
  },

  render: function render() {
    var optionsStyle = this.props.isExpanded && !this.props.disableDropdown ? {} : { display: 'none' };

    if (this.props.style.optionsContainerStyle) {
      optionsStyle = _extends({}, optionsStyle, this.props.style.optionsContainerStyle);
    }

    var child = this.getDisplayingChild();

    return React.createElement(
      'div',
      {
        className: this.props.containerClassName,
        style: this.props.style.selectContainerStyle || {}
      },
      React.createElement(
        'div',
        {
          onClick: this.props.isExpanded ? this.props.onClosed : this.props.onExpanded
        },
        this.props.displayingChildRenderer(child, this.props.isExpanded, this.props.isFocused)
      ),
      React.createElement(
        'div',
        {
          style: optionsStyle,
          className: this.props.optionsContainerClassName
        },
        this.createInteractiveOptions()
      )
    );
  }
});

exports['default'] = InertSelect;
module.exports = exports['default'];