'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var Option = (0, _createReactClass2['default'])({
  propTypes: {
    children: _propTypes2['default'].oneOfType([_propTypes2['default'].node, _propTypes2['default'].func]).isRequired,
    value: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number]).isRequired,
    label: _propTypes2['default'].oneOfType([_propTypes2['default'].string, _propTypes2['default'].number]).isRequired,

    isHovering: _propTypes2['default'].bool,
    isActive: _propTypes2['default'].bool,
    isSelected: _propTypes2['default'].bool,
    isDisplaying: _propTypes2['default'].bool,

    onMouseOver: _propTypes2['default'].func.isRequired,
    onMouseUp: _propTypes2['default'].func.isRequired,
    onMouseDown: _propTypes2['default'].func.isRequired
  },

  getDefaultProps: function getDefaultProps() {
    return {
      onMouseOver: function onMouseOver() {},
      onMouseUp: function onMouseUp() {},
      onMouseDown: function onMouseDown() {}
    };
  },

  shouldComponentUpdate: function shouldComponentUpdate(nextProps) {
    return this.props.isHovering !== nextProps.isHovering || this.props.isActive !== nextProps.isActive || this.props.isSelected !== nextProps.isSelected || this.props.isDisplaying || this.props.isDisplaying !== nextProps.isDisplaying;
  },

  getRenderable: function getRenderable() {
    var children = this.props.children;
    return typeof children === 'function' ? children(this.props.isHovering, this.props.isActive, this.props.isSelected, this.props.isDisplaying) : children;
  },

  render: function render() {
    return _react2['default'].createElement(
      'div',
      {
        onMouseOver: this.props.onMouseOver,
        onMouseUp: this.props.onMouseUp,
        onMouseDown: this.props.onMouseDown
      },
      this.getRenderable()
    );
  }
});

exports['default'] = Option;
module.exports = exports['default'];